canvas .c
pack .c

proc mkNode {x y} {		
	global nodeX nodeY edgeFirst edgeSecond 
	set new [.c create oval [expr $x-10] [expr $y-10] \
		[expr $x+10] [expr $y+10] -outline black \
		-fill white -tags node]
set nodeX($new) $x
set nodeY($new) $y
set edgeFirst($new) {}
set edgeSecond($new) {}
}
proc mkEdge {first second} { 
	global nodeX nodeY edgeFirst edgeSecond
	set edge [.c create line $nodeX($first) $nodeY($first) \
		$nodeX($second) $nodeY($second)]
	.c lower $edge
	lappend edgeFirst($first) $edge
	lappend edgeSecond($second) $edge
}
bind .c <Button-1> {mkNode %x %y}
.c bind node <Any-Enter> {
	.c itemconfigure current -fill black
}
.c bind node <Any-Leave> {
	.c itemconfigure current -fill white 
}
bind .c 1 {set firstNode [.c find withtag current]}
bind .c 2 {
	set curNode [.c find withtag current]
	if {($firstNode != "") && ($curNode != "")} {
		mkEdge $firstNode $curNode
	}
}
